package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseUnit;
import com.ruoyi.web.base.service.IBaseUnitService;
import com.ruoyi.web.base.service.IBaseUnitService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 * 单位 前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-06
 */
@RestController
@RequestMapping("/base-unit")
public class BaseUnitController {
    @Autowired
    private IBaseUnitService baseUnitService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("单位管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseUnit baseUnit, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseUnitService.count(new QueryWrapper<BaseUnit>().eq("org_id",loginOrgId).eq("unit_name", baseUnit.getUnitName())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseUnit.setOrgId(loginOrgId);
        baseUnit.setCreateBy(getUsername());

        return success(baseUnitService.save(baseUnit));
    }

    @ApiOperation("仓库管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseUnit baseUnit, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseUnitService.count(new QueryWrapper<BaseUnit>().ne("id",baseUnit.getId()).eq("org_id",loginOrgId).eq("unit_name", baseUnit.getUnitName())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseUnit.setUpdateBy(getUsername());
        return success(baseUnitService.updateById(baseUnit));
    }

    @ApiOperation("仓库管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            baseUnitService.removeById(s);
        }
        return success();
    }

    @ApiOperation("仓库管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){

        return success(baseUnitService.list(new QueryWrapper<BaseUnit>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("仓库管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize
            , HttpServletRequest request) {
        return success(baseUnitService.page(new Page<BaseUnit>(pageNum,pageSize),new QueryWrapper<BaseUnit>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("仓库管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(baseUnitService.getById(id));
    }


}
